#!/sbin/sh
#************************************************************ 
#
# Component      Multi protocol command line manager
#
# Synopsis       easymanager startup script 
#
# Copyright 2000-2004 Sun Microsystems, Inc. All rights reserved.
#
# ident  "@(#)ma 1.8     01/06/06 SMI"
#
###############################################################################

if [ "$1" = "-h" ]
then
echo "\neasymanager is a simple SNMP V1, V2 and V3 command line manager". 
echo "based on JDMK. Type help on command line to display commands.\n"
echo "usage : sh ./easymanager.sh {-h} {-t} {-crypto} {-host agent host} {-port agent port} "
echo "\t -t         : To activate debug outputs."
echo "\t -crypto    : To activate cryptographie.\n"
echo "\t -host agent host : The agent host. The default value is localhost."
echo "\t -port agent port : The agent port. The default value is 8085. Traps are "
echo "\t received on agent port + 1 (default value 8086)."
echo "It allows you to:"
echo "\t * Quickly test your development."
echo "\t * Load mib table symbols. MIB II is loaded by default. MIB tables are"
echo "\t   looked for in easymanager CLASSPATH then in your CLASSPATH."
echo "\t * Send get, getnext, getbulk, set requests in SNMP V1, V2 and V3."
echo "\t * Load your own SNMP V3 security file. You need to set SNMPV3_FILE env "
echo "\t   to your JDMK security file full name."
echo "\t * Receive trap and informs in a separate window."
echo "\n"
exit 0;
fi
here=`dirname $0`
JDMK_HOME=${JDMK_HOME:=$here/../../../../build}
JDMK_EM_HOME=${JDMK_HOME}/contributions/delivery/easymanager

if [ ! -x "${JDMK_HOME}" ]
    then 
	echo "${JDMK_HOME}: JDMK_HOME is not properly set....\n"
	exit 1;
fi

if [ -z "${SNMPV3_FILE}" ]
    then 
	echo "WARNING : SNMPV3_FILE var env not set, using etc directory one.\n"
	SNMPV3_FILE=$JDMK_EM_HOME/etc/jdmk.security
fi

if [ ! -r "${SNMPV3_FILE}" ]
     then
	echo "${SNMPV3_FILE}: SNMPV3_FILE is not properly set....\n"
	exit 1;
fi

# easymanager jar
echo " TO CHANGE IN FINAL RELEASE, MUST BE SET TO contributions/lib/easymanager.jar"
jeasymanager_jar=$JDMK_EM_HOME/lib/easymanager.jar
if [ ! -r "${jeasymanager_jar}" ]
     then
	echo "${jeasymanager_jar}: easymanager.jar not found....\n"
	exit 1;
fi


# jmx jar
jmxri_jar=/qa/jmx/deliveries/latestjmx/lib/jmxri.jar
jmx_remote_jar=/qa/jmx/deliveries/latestjmxremote/lib/jmxremote.jar
jmx_remote_optional_jar=/qa/jmx/deliveries/latestjmxremote/lib/jmxremote_optional.jar
jmx_jar=${jmxri_jar}:${jmx_remote_jar}:${jmx_remote_optional_jar}

# jdmk jars
jdmkrt_jar=$JDMK_HOME/lib/jdmkrt.jar

CLASSPATHFLAG=-classpath
CLASSPATH_VALUE="$CLASSPATH:"$jmx_jar":"$jeasymanager_jar":"$jdmkrt_jar:"$jsnmpapi_jar"
SECURITY_FILE=-Djdmk.security.file
EASYMANAGER=com.sun.management.snmp.easymanager.SimpleManager

if [ "$1" = "-t" ]
then
DEBUG=-DLEVEL_DEBUG
shift
fi

java $DEBUG $CLASSPATHFLAG "$CLASSPATH_VALUE" $SECURITY_FILE=$SNMPV3_FILE $EASYMANAGER "$@"


