/*
 * @(#)file      SnmpMibValidator.java
 * @(#)author    Sun Microsystems, Inc.
 * @(#)version   1.7
 * @(#)lastedit  04/05/10
 * 
 * Copyright 2003 Sun Microsystems, Inc. All rights reserved.
 * SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
package validator;

import java.util.ArrayList;
import java.util.Iterator;

import com.sun.management.snmp.manager.SnmpSession;
import com.sun.management.snmp.SnmpStatusException;

public class SnmpMibValidator {
    ArrayList validations = new ArrayList();
    
    public SnmpMibValidator() {
    }
    
    public void addValidation(SnmpMibValidation validation) {
	validations.add(validation);
    }
    
    public void validate() throws SnmpStatusException {
	boolean error = false;
	SnmpSession session = new SnmpSession("MibValidator");
	Iterator i = validations.iterator();
	while(i.hasNext()) {
	    SnmpMibValidation validation = (SnmpMibValidation) i.next();
	    try {
		validation.validate(session);
	    }catch(Exception e) {
		error = true;
	    }
	}
	session.destroySession();
	if(error) 
	    throw new SnmpStatusException("VALIDATION FAILED, " + 
					  "CHECK SEVERE TRACES");
    }
}
