/*
 * @(#)file      Validator.java
 * @(#)author    Sun Microsystems, Inc.
 * @(#)version   1.4
 * @(#)lastedit  04/05/10
 * 
 * Copyright 2003 Sun Microsystems, Inc. All rights reserved.
 * SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
package validator;

import java.io.File;
import java.net.URI;
import java.net.URL;

import com.sun.jdmk.trace.Trace;
import com.sun.jdmk.TraceManager;

import validator.XMLMibValidationDOMParser;
import validator.SnmpMibValidator;
public class Validator {
    public static void main(String[] args) {
	
	if(args.length == 0) {
	    System.out.println("Usage Validator <schema file> <xml validation file>");
	    System.exit(1);
	}
	// Initialize trace property.
        // 
        try {
            TraceManager.parseTraceProperties();
            Trace.send(Trace.LEVEL_TRACE, 
		       Trace.INFO_MISC, 
		       "mibvalidator", 
		       "main", 
		       "Default trace is on");
        } catch(java.io.IOException e) {
            e.printStackTrace();
        }
	File file = null;
	File schema = null;
	try {
	    schema = new File(args[0]);
	}catch(Exception e) {
	    System.out.println("Invalid xml schema file");
	    System.exit(1);
	}
	try {
	    file = new File(args[1]);
	}catch(Exception e) {
	    System.out.println("Invalid xml validation file");
	    System.exit(1);
	}
	
	SnmpMibValidator validator = null;
	try {
	    XMLMibValidationDOMParser parser = 
		new XMLMibValidationDOMParser(schema);
	    
	    validator = parser.parseMibValidation(file);
	}catch(Exception e) {
	    System.out.println("Exception while parsing : " + e.toString());
	    System.exit(1);
	}
	try {
	    validator.validate();
	}catch(Exception e) {
	    System.out.println("Exception while validating : " + e.toString());
	    System.exit(1);
	}
    }
}
