/*
 * @(#)file      SnmpJdmkTargetLcd.java
 * @(#)author    Sun Microsystems, Inc.
 * @(#)version   1.7
 * @(#)date      04/07/05
 *
 * Copyright 2000-2004 Sun Microsystems, Inc.  All rights reserved.
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 * 
 * Copyright 2000-2004 Sun Microsystems, Inc.  Tous droits r?serv?s.
 * Ce logiciel est propriet? de Sun Microsystems, Inc.
 * Distribu? par des licences qui en restreignent l'utilisation. 
 *
 */

package com.sun.management.snmp.rfc2573.internal.target;


import java.util.Enumeration;

import com.sun.management.snmp.rfc2573.target.SnmpTargetLcd;
import com.sun.management.snmp.rfc2573.internal.SnmpAddressFactory;
import com.sun.management.snmp.rfc2573.target.SnmpParamsData;
import com.sun.management.snmp.rfc2573.target.SnmpTargetData;

import com.sun.management.snmp.SnmpEngine;

public class SnmpJdmkTargetLcd implements SnmpTargetLcd {
    SnmpTargetsReader targets = null;
    SnmpParamsReader params = null;
    SnmpPeerFactory peerFactory = null;
    SnmpAddressFactory addressFactory = null;
    String targetsFile = null;
    String paramsFile = null;
    boolean init = false;
    SnmpEngine engine = null;
    public SnmpJdmkTargetLcd(SnmpEngine engine,
			     String paramsFile,
			     String targetsFile) {
	this.engine = engine;
	this.targetsFile = targetsFile;
	this.paramsFile = paramsFile;
    }
    
    public SnmpParamsData getParams(String name) {
	return params.getParams(name);
    }
    
    public SnmpTargetData getTarget(String name) {
	return targets.getTarget(name);
    }

    public void addTarget(String targetsName,
			  String domain,
			  Byte[] address,
			  int timeout,
			  int retry,
			  String tags,
			  String paramsName,
			  int storageType) throws IllegalArgumentException {
	targets.addTarget(targetsName,
			  domain,
			  address,
			  timeout,
			  retry,
			  tags,
			  paramsName,
			  storageType);
    }
    
    public void removeTarget(String targetName) 
	throws IllegalArgumentException {
	targets.removeTarget(targetName);
    }
    
    /**
     * Enumeration of <CODE>SnmpParamsData</CODE>
     */
    public Enumeration getParams() {
	return params.getParams();
    }
    /**
     * Enumeration of <CODE>SnmpTargetsData</CODE>
     */
    public Enumeration getTargets() {
	return targets.getTargets();
    }

    public void addParams(String paramsName,
			  int mpm,
			  int securityModel,
			  String securityName,
			  int securityLevel,
			  int storageType) throws IllegalArgumentException {
	params.addParams(paramsName,
			 mpm,
			 securityModel,
			 securityName,
			 securityLevel,
			 storageType);
    }
    
    public void removeParams(String paramsName) 
	throws IllegalArgumentException {
	params.removeParams(paramsName);
    }

    public void readConfiguration() {
	if(init) return;
	//Params only, no dependency
	
	params = new SnmpParamsReader(paramsFile);
	if(peerFactory == null) 
	    peerFactory = new SnmpPeerFactory();
	
	if(addressFactory == null)
	    addressFactory = new SnmpAddressFactory();
	
	targets = new SnmpTargetsReader(engine,
					addressFactory,
					peerFactory,
					params,
					targetsFile);
	init = true;
    }

    /**
     * To allow your own peer creation.
     */
    public void setPeerFactory(SnmpPeerFactory fact) {
	peerFactory = fact;
    }

    public SnmpPeerFactory getPeerFactory() {
	return peerFactory;
    }

     public SnmpAddressFactory getAddressFactory() {
	return addressFactory;
    }
}
