/*
 * @(#)file      SnmpRfc2573NotificationManager.java
 * @(#)author    Sun Microsystems, Inc.
 * @(#)version   1.10
 * @(#)date      04/07/05
 *
 * Copyright 2000-2004 Sun Microsystems, Inc.  All rights reserved.
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 * 
 * Copyright 2000-2004 Sun Microsystems, Inc.  Tous droits r?serv?s.
 * Ce logiciel est propriet? de Sun Microsystems, Inc.
 * Distribu? par des licences qui en restreignent l'utilisation. 
 *
 */
package com.sun.management.snmp.rfc2573.manager.notification;


// Util import
import java.util.Enumeration;

// JMX RI import
import com.sun.management.snmp.SnmpDefinitions;
import com.sun.management.snmp.SnmpStatusException;
import com.sun.management.snmp.manager.SnmpSession;

// Contrib MGR import
import com.sun.management.snmp.rfc2573.manager.internal.notification.SnmpNotificationHandler;
import com.sun.management.snmp.rfc2573.manager.internal.notification.SnmpNotificationData;

public class  SnmpRfc2573NotificationManager {

    /** 
     * Register Notification
     */
    public static void registerNotif(SnmpSession session,
			      String notifyIndex, 
			      String tag, 
			      int pduType,
			      int storage)
 
	throws SnmpStatusException {
	
	// new data to set in the MIB
	SnmpNotificationData data = new SnmpNotificationData();

	// Set the data to add
	data.notifyName = notifyIndex;
	data.notifyTag  = tag;
	data.notifyType = pduType;
	data.notifyStorage = storage;
	SnmpNotificationHandler.setNotif(session, data);
    }

    public static void unregisterNotif(SnmpSession session,
				String notifyIndex) 
	throws SnmpStatusException {
	SnmpNotificationHandler.removeNotif(session, notifyIndex);
    }

}
