/*
 * @(#)file      SnmpParamsData.java
 * @(#)author    Sun Microsystems, Inc.
 * @(#)version   1.5
 * @(#)date      04/07/05
 *
 * Copyright 2000-2004 Sun Microsystems, Inc.  All rights reserved.
 * This software is the proprietary information of Sun Microsystems, Inc.
 * Use is subject to license terms.
 * 
 * Copyright 2000-2004 Sun Microsystems, Inc.  Tous droits r?serv?s.
 * Ce logiciel est propriet? de Sun Microsystems, Inc.
 * Distribu? par des licences qui en restreignent l'utilisation. 
 *
 */
package com.sun.management.snmp.rfc2573.target;

import com.sun.management.snmp.SnmpDefinitions;

public class SnmpParamsData implements Cloneable {
    public String paramsName = null;
    public int mpm = -1;
    public int securityModel = -1;
    public String securityName = null;
    public int securityLevel = -1;
    public int storageType = 0;
    public Object clone() throws CloneNotSupportedException {
	return super.clone();
    }
    
    public String toString() {
	return paramsName +"," + mpm + "," + securityModel +"," + securityName + "," + securityLevel + "," + storageType;
    }
    
    public static int translateMIBSecurityLevel(int mibSecurityLevel) {
	switch(mibSecurityLevel) {
	case 1:
	    return SnmpDefinitions.noAuthNoPriv;
	case 2:
	    return SnmpDefinitions.authNoPriv;
	case 3:
	    return SnmpDefinitions.authPriv;
	default:
	    return -1;
	}
    }
}
